Fetch All Saved Card Instrument
curl --request GET \
--url 'https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card' \
--header 'x-api-version: <x-api-version>' \
--header 'x-client-id: <api-key>' \
--header 'x-client-secret: <api-key>'import requests
url = "https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card"
headers = {
"x-api-version": "<x-api-version>",
"x-client-id": "<api-key>",
"x-client-secret": "<api-key>"
}
response = requests.get(url, headers=headers)
print(response.text)const options = {
method: 'GET',
headers: {
'x-api-version': '<x-api-version>',
'x-client-id': '<api-key>',
'x-client-secret': '<api-key>'
}
};
fetch('https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "GET",
CURLOPT_HTTPHEADER => [
"x-api-version: <x-api-version>",
"x-client-id: <api-key>",
"x-client-secret: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"net/http"
"io"
)
func main() {
url := "https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card"
req, _ := http.NewRequest("GET", url, nil)
req.Header.Add("x-api-version", "<x-api-version>")
req.Header.Add("x-client-id", "<api-key>")
req.Header.Add("x-client-secret", "<api-key>")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.get("https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card")
.header("x-api-version", "<x-api-version>")
.header("x-client-id", "<api-key>")
.header("x-client-secret", "<api-key>")
.asString();require 'uri'
require 'net/http'
url = URI("https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
request["x-api-version"] = '<x-api-version>'
request["x-client-id"] = '<api-key>'
request["x-client-secret"] = '<api-key>'
response = http.request(request)
puts response.read_body[
{
"customer_id": "akshita2106",
"afa_reference": "2223295743",
"instrument_id": "0d6b0245-f417-41a0-8151-0b03790de1f9",
"instrument_type": "card",
"instrument_uid": "a89b6054bd18f3f4a2e6663190c23aa7f39573dfde2ea2e5d3dbf1b31705f0da",
"instrument_display": "XXXXXXXXXXXX5717",
"instrument_status": "ACTIVE",
"created_at": "2023-11-01T04:55:07.000+00:00",
"instrument_meta": {
"card_network": "visa",
"card_bank_name": "AXIS BANK",
"card_country": "IN",
"card_type": "credit_card",
"card_sub_type": "P",
"card_token_details": {
"par": "V0010013823048595023916090696",
"expiry_month": "05",
"expiry_year": "2028"
}
}
},
{
"customer_id": "akshita2106",
"afa_reference": "2372080606",
"instrument_id": "36e3b8ab-27e5-4a33-baf6-31a2d412a530",
"instrument_type": "card",
"instrument_uid": "b6f4e24db8ab83e59dc57049b25f0fdfa9b730e329b9730d3d3fe0aba3ccfaa3",
"instrument_display": "XXXXXXXXXXXX7293",
"instrument_status": "ACTIVE",
"created_at": "2024-01-04T09:16:37.000+00:00",
"instrument_meta": {
"card_network": "mastercard",
"card_bank_name": "PUNJAB NATIONAL BANK",
"card_country": "IN",
"card_type": "debit_card",
"card_sub_type": "R",
"card_token_details": {
"par": "5001D6TQMCHMY7SHM2SFANC3AWFSD",
"expiry_month": 9,
"expiry_year": "2028"
}
}
},
{
"customer_id": "akshita2106",
"afa_reference": "3128531647",
"instrument_id": "0d6b0245-f417-41a0-8151-0b03790de1f9",
"instrument_type": "card",
"instrument_uid": "a89b6054bd18f3f4a2e6663190c23aa7f39573dfde2ea2e5d3dbf1b31705f0da",
"instrument_display": "XXXXXXXXXXXX1001",
"instrument_status": "ACTIVE",
"created_at": "2024-10-10T10:16:18.000+00:00",
"instrument_meta": {
"card_network": "mastercard",
"card_bank_name": "ICICI BANK",
"card_country": "IN",
"card_type": "credit_card",
"card_sub_type": "P",
"card_token_details": {
"par": "5001AJE6CSF757UMKRTKK61PRVYGC",
"expiry_month": "11",
"expiry_year": "2027"
}
}
}
]{
"message": "bad URL, please check API documentation",
"help": "Check latest errors and resolution from Merchant Dashboard API logs: https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9",
"code": "request_failed",
"type": "invalid_request_error"
}{
"message": "authentication Failed",
"code": "request_failed",
"type": "authentication_error"
}{
"message": "something is not found",
"help": "Check latest errors and resolution from Merchant Dashboard API logs: https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9",
"code": "something_not_found",
"type": "invalid_request_error"
}{
"message": "order with same id is already present",
"help": "Check latest errors and resolution from Merchant Dashboard API logs: https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9",
"code": "order_already_exists",
"type": "invalid_request_error"
}{
"message": "something is not found",
"help": "Check latest errors and resolution from Merchant Dashboard API logs: https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9",
"code": "request_invalid",
"type": "idempotency_error"
}{
"message": "Too many requests from IP. Check headers",
"code": "request_failed",
"type": "rate_limit_error"
}{
"message": "internal Server Error",
"help": "Check latest errors and resolution from Merchant Dashboard API logs: https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9",
"code": "internal_error",
"type": "api_error"
}Token Vault
Fetch All Saved Card Instrument
Use this API to fetch all saved cards stored for the customer in Cashfree’s Token Vault.
GET
/
customers
/
{customer_id}
/
instruments?instrument_type=card
Fetch All Saved Card Instrument
curl --request GET \
--url 'https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card' \
--header 'x-api-version: <x-api-version>' \
--header 'x-client-id: <api-key>' \
--header 'x-client-secret: <api-key>'import requests
url = "https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card"
headers = {
"x-api-version": "<x-api-version>",
"x-client-id": "<api-key>",
"x-client-secret": "<api-key>"
}
response = requests.get(url, headers=headers)
print(response.text)const options = {
method: 'GET',
headers: {
'x-api-version': '<x-api-version>',
'x-client-id': '<api-key>',
'x-client-secret': '<api-key>'
}
};
fetch('https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "GET",
CURLOPT_HTTPHEADER => [
"x-api-version: <x-api-version>",
"x-client-id: <api-key>",
"x-client-secret: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"net/http"
"io"
)
func main() {
url := "https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card"
req, _ := http.NewRequest("GET", url, nil)
req.Header.Add("x-api-version", "<x-api-version>")
req.Header.Add("x-client-id", "<api-key>")
req.Header.Add("x-client-secret", "<api-key>")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.get("https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card")
.header("x-api-version", "<x-api-version>")
.header("x-client-id", "<api-key>")
.header("x-client-secret", "<api-key>")
.asString();require 'uri'
require 'net/http'
url = URI("https://sandbox.cashfree.com/pg/customers/{customer_id}/instruments?instrument_type=card")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
request["x-api-version"] = '<x-api-version>'
request["x-client-id"] = '<api-key>'
request["x-client-secret"] = '<api-key>'
response = http.request(request)
puts response.read_body[
{
"customer_id": "akshita2106",
"afa_reference": "2223295743",
"instrument_id": "0d6b0245-f417-41a0-8151-0b03790de1f9",
"instrument_type": "card",
"instrument_uid": "a89b6054bd18f3f4a2e6663190c23aa7f39573dfde2ea2e5d3dbf1b31705f0da",
"instrument_display": "XXXXXXXXXXXX5717",
"instrument_status": "ACTIVE",
"created_at": "2023-11-01T04:55:07.000+00:00",
"instrument_meta": {
"card_network": "visa",
"card_bank_name": "AXIS BANK",
"card_country": "IN",
"card_type": "credit_card",
"card_sub_type": "P",
"card_token_details": {
"par": "V0010013823048595023916090696",
"expiry_month": "05",
"expiry_year": "2028"
}
}
},
{
"customer_id": "akshita2106",
"afa_reference": "2372080606",
"instrument_id": "36e3b8ab-27e5-4a33-baf6-31a2d412a530",
"instrument_type": "card",
"instrument_uid": "b6f4e24db8ab83e59dc57049b25f0fdfa9b730e329b9730d3d3fe0aba3ccfaa3",
"instrument_display": "XXXXXXXXXXXX7293",
"instrument_status": "ACTIVE",
"created_at": "2024-01-04T09:16:37.000+00:00",
"instrument_meta": {
"card_network": "mastercard",
"card_bank_name": "PUNJAB NATIONAL BANK",
"card_country": "IN",
"card_type": "debit_card",
"card_sub_type": "R",
"card_token_details": {
"par": "5001D6TQMCHMY7SHM2SFANC3AWFSD",
"expiry_month": 9,
"expiry_year": "2028"
}
}
},
{
"customer_id": "akshita2106",
"afa_reference": "3128531647",
"instrument_id": "0d6b0245-f417-41a0-8151-0b03790de1f9",
"instrument_type": "card",
"instrument_uid": "a89b6054bd18f3f4a2e6663190c23aa7f39573dfde2ea2e5d3dbf1b31705f0da",
"instrument_display": "XXXXXXXXXXXX1001",
"instrument_status": "ACTIVE",
"created_at": "2024-10-10T10:16:18.000+00:00",
"instrument_meta": {
"card_network": "mastercard",
"card_bank_name": "ICICI BANK",
"card_country": "IN",
"card_type": "credit_card",
"card_sub_type": "P",
"card_token_details": {
"par": "5001AJE6CSF757UMKRTKK61PRVYGC",
"expiry_month": "11",
"expiry_year": "2027"
}
}
}
]{
"message": "bad URL, please check API documentation",
"help": "Check latest errors and resolution from Merchant Dashboard API logs: https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9",
"code": "request_failed",
"type": "invalid_request_error"
}{
"message": "authentication Failed",
"code": "request_failed",
"type": "authentication_error"
}{
"message": "something is not found",
"help": "Check latest errors and resolution from Merchant Dashboard API logs: https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9",
"code": "something_not_found",
"type": "invalid_request_error"
}{
"message": "order with same id is already present",
"help": "Check latest errors and resolution from Merchant Dashboard API logs: https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9",
"code": "order_already_exists",
"type": "invalid_request_error"
}{
"message": "something is not found",
"help": "Check latest errors and resolution from Merchant Dashboard API logs: https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9",
"code": "request_invalid",
"type": "idempotency_error"
}{
"message": "Too many requests from IP. Check headers",
"code": "request_failed",
"type": "rate_limit_error"
}{
"message": "internal Server Error",
"help": "Check latest errors and resolution from Merchant Dashboard API logs: https://bit.ly/4glEd0W Help Document: https://bit.ly/4eeZYO9",
"code": "internal_error",
"type": "api_error"
}Authorizations
XClientID & XClientSecretXClientID & XPartnerAPIKeyXClientID & XClientSignatureHeaderXPartnerMerchantID & XPartnerAPIKey
Client app ID. You can find your app id in the Merchant Dashboard.
Client secret key. You can find your secret key in the Merchant Dashboard.
Headers
Path Parameters
The customer ID provided by the merchant during the Create Order API call, used to save cards for the customer.
Query Parameters
Response
Success response for fetching all saved cards for a customer. Filter the saved cards by token expiry to show only active cards on your checkout.
Customer ID that merchant sends during Create Order API, against which the cards are saved for the customer.
Identifier for the card saved at Cashfree. It is used for cryptogram generation and in order pay request for saved cards..
Was this page helpful?